<?php
# ***** BEGIN LICENSE BLOCK *****
# Tribune Libre for DotClear.
# Copyright (c) 2005 Antoine Libert. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


require dirname(__FILE__)."/functions.php";

/////////////////////////////////////////////////
// Définission des variables

$pluginName = "neolao";
$pluginPath = "share/".$pluginName;
$mediaDirectory = "share/".$pluginName;
$playerDirectory = $pluginPath."/player";
$url = "tools.php?p=".$pluginName;

$fileslist = array(
	'share/neolao/player/player_mp3_maxi.swf',
	'share/neolao/player/player_flv_maxi.swf',
	'share/neolao/player/player_mp3_multi.swf',
);

////////////////////////////////////////////////
// Chargement des properties du fichier ini

$iniFilePath = dirname(__FILE__).'/neolao.ini';
$objIni = new iniFile($iniFilePath);
$objIni->read($iniFilePath);


///////////////////////////////////////////////
// TODO A SUPPRIMER ...

// On est dans le répertoire '/ecrire' ..
chdir("../");


/////////////////////////////////////////////////
// Répertoire des Médias

if (!is_dir($mediaDirectory)){
	
	// On créé le répoertoire d'échange si il n'existe pas.
	$is_dir_created = mkdir($mediaDirectory);
	if (!$is_dir_created) {
		$message = __('Share directory is not writable');
		exit;
	}  else {
		$message = __('Share directory created');
	}
}

if (!is_dir($playerDirectory)){
	mkdir($playerDirectory);
}

foreach ($fileslist as $file) {
		dcNeolao::replace($file);
	}
	
/////////////////////////////////////////////////
// Traitement de l'action demandée

if (isset($_POST['action'])){

	$action = $_POST['action'];

	/** Sauve le fichier sur le serveur */

	if ($action=="upload" && isset($_FILES['file']) && is_uploaded_file($_FILES['file']['tmp_name']))
	{

		$filePath = $mediaDirectory."/".urlencode($_FILES['file']['name']);

		copy($HTTP_POST_FILES['file']['tmp_name'],$filePath);
		unlink($HTTP_POST_FILES['file']['tmp_name']);
		
		$message = __('File correctly uploaded');

	}

	/** Sauvegarde les propriétés dans le fichier ini */

	else if ($action=="properties")
	{
		// Edition des variables
		$objIni->editVar('autoPlay', $_POST['autoPlay']);
		$objIni->editVar('bgColor', $_POST['bgColor']);
		$objIni->editVar('width', $_POST['width']);
		$objIni->editVar('height', $_POST['height']);
		$objIni->editVar('displayPodcastLogo', $_POST['displayPodcastLogo']);
		$objIni->editVar('showtime', $_POST['showtime']);
		$objIni->editVar('showstop', $_POST['showstop']);
		$objIni->editVar('showvolume', $_POST['showvolume']);
		$objIni->editVar('bgcolor1', $_POST['bgcolor1']);
		$objIni->editVar('bgcolor2', $_POST['bgcolor2']);
		$objIni->editVar('playercolor', $_POST['playercolor']);

		// Sauvegarde les properties dans le fichier ini
		$objIni->saveFile();
		
		$message = __('Properties corectly updated');
	}
}




/////////////////////////////////////////////////
// Header de la page

$mySubMenu->addItem('Neolao', $url, 'images/ico_goto.png', FALSE);

buffer::str('<h2>Neolao</h2>');

/////////////////////////////////////////////////
// Affichage des fichiers présents sur la machine

buffer::str('<fieldset class="clear">');
buffer::str('<legend>'.__('Mp3 & FLV Files').'</legend>');

if ($handle = opendir($mediaDirectory)) {

   $fileCount = 0;
   
   while (false !== ($file = readdir($handle)))
   {
       if ($file != "." && $file != ".." && $file != "player") {

			
			$filepath = $mediaDirectory ."/".$file;

			if (isset($_GET['delete']) && (fileinode($filepath) == $_GET['delete']))
			{
				// Si il s'agit du fichier sélectionné pour
				// la suppression alors on le supprime

				unlink($filepath);
				
				$message = __('File deleted');
			}
			else
			{
				// Sinon on affiche le fichier dans la liste des fichiers.

				buffer::str('<div class="ligne clear">');
				buffer::str('<h3 class="ligneTitre">'.$file.'</h3>');
				buffer::str('<p class="semi"><b>'.__('File Size').' :</b> '. round(filesize($filepath)/(1024*1024),2) .' Mb</p>');
				buffer::str('<p class="semi"><b>'.__('Creation Date').' :</b> '.date ("d/m/Y.", filemtime($filepath)).'</p>');

				buffer::str('<a href="tools.php?p='.$pluginName.'&code='.fileinode($filepath).'"><img src="images/ico_link.png" alt="'.__('XHTML Code').'" title="supprimer"/> '.__('Code XHTML').'</a>  ');

				if (is_writable($filepath)){
					buffer::str('<a href="tools.php?p='.$pluginName.'&delete='.fileinode($filepath).'" onclick="return window.confirm(\''.__('This MP3 will be removed from the server').'\')"><img src="images/delete.png" alt="'.__('Delete').'" title="supprimer"/> '.__('Delete').'</a><br/><br/>');
				}

				buffer::str('</div>');
				
				// Si il s'agit du fichier dont on désire avoir le code XHTML
				if (isset($_GET['code']) && (fileinode($filepath) == $_GET['code']))
				{
					$filePath = $mediaDirectory."/".urlencode($file);
					$message = __('XHTML code generated bellow');
				}
				
				// On incrémente ne nombre de fichiers trouvés
				$fileCount++;
			}
		
		}

	}
	closedir($handle);
}

buffer::str('<p><b>'.$fileCount.' '.__('Files founds').'</b></p>');

buffer::str('</fieldset>');

/////////////////////////////////////////////////
// Affiche des messages

if (!isset($message)) {
   $message = __('Neolao helps you to insert a media player in your posts');
}

buffer::str('<fieldset class="clear">');
buffer::str('<legend>'.__('Message').'</legend>');
buffer::str('<i><img src="images/ico_new.png" alt="'.__('Message').'" title="message"/> '.$message.'</i>');
buffer::str('</fieldset>');


//////////////////////////////////////////////////
// Affichage du formulaire d'envoi de MP3

buffer::str('<fieldset class="clear">');

buffer::str('<legend>'.__('Mp3 & FLV Upload').'</legend>');
buffer::str('<form action="tools.php?p='.$pluginName.'" method="post" enctype="multipart/form-data">');
buffer::str('<input type="hidden" name="action" value="upload"/>');
buffer::str('<input type="hidden" name="MAX_FILE_SIZE" value="33554432"/>');
buffer::str(__('File').' : <input type="file" name="file" /><br/><br/>');
buffer::str('<input type="submit" name="submit" class="submit" value="'.__('Submit').'" />');
buffer::str('<p>' . dcNonce::form() . '</p>');
buffer::str('</form>');

buffer::str('</fieldset>');


//////////////////////////////////////////////////
// Propriétés d'affichage
buffer::str('<fieldset class="clear">');
buffer::str('<fieldset class="clear" style="width: 44.25%; float: left; margin: 0 2% 0 0;">');

buffer::str('<legend>'.__('Display Properties').'</legend>');
buffer::str('<form action="tools.php?p='.$pluginName.'" method="post">');
buffer::str('<input type="hidden" name="action" value="properties"/>');

// Affichage du logo PodCast
buffer::str('<p class="field"><label for="displayPodcastLogo"><strong>'.__('Display Podcast logo').' :</strong></label><select name="displayPodcastLogo" id="displayPodcastLogo">');

if (displayPodcastLogo=="1"){
	buffer::str('<option value="1" selected="selected">'.__('yes').'</option><option value="0">'.__('no').'</option>');
} else {
	buffer::str('<option value="1">'.__('yes').'</option><option value="0" selected="selected">'.__('no').'</option>');
}

buffer::str('</select></p>');


// Lecture automatique
buffer::str('<p class="field"><label for="autoPlay"><strong>'.__('Autoplay').' :</strong></label><select name="autoPlay" id="autoPlay">');

if (autoPlay=="1"){
		buffer::str('<option value="1" selected="selected">'.__('yes').'</option><option value="0">'.__('no').'</option>');
	} else {
		buffer::str('<option value="1">'.__('yes').'</option><option value="0" selected="selected">'.__('no').'</option>');
	}

buffer::str('</select></p>');

// Options diverses
buffer::str('<p class="field"><label for="showtime"><strong>'.__('Time').' :</strong></label><select name="showtime" id="showtime">');

	if (showtime=="1"){
		buffer::str('<option value="1" selected="selected">'.__('elapsed time').'</option><option value="2">'.__('remaining time').'<option value="0">'.__('no').'</option>');
	} elseif(showtime=="2") {
		buffer::str('<option value="1">'.__('elapsed time').'</option><option value="2" selected="selected">'.__('remaining time').'<option value="0">'.__('no').'</option>');
	} else {
		buffer::str('<option value="1">'.__('elapsed time').'</option><option value="2">'.__('remaining time').'<option value="0" selected="selected">'.__('no').'</option>');
	}
buffer::str('</select></p>');
buffer::str('<p class="field"><label for="showstop"><strong>'.__('Stop button').' :</strong></label><select name="showstop" id="showstop">');

	if (showstop=="1"){
		buffer::str('<option value="1" selected="selected">'.__('yes').'</option><option value="0">'.__('no').'</option>');
	} else {
		buffer::str('<option value="1">'.__('yes').'</option><option value="0" selected="selected">'.__('no').'</option>');
	}
buffer::str('</select></p>');
buffer::str('<p class="field"><label for="showvolume"><strong>'.__('Volume').' :</strong></label><select name="showvolume" id="showvolume">');

	if (showvolume=="1"){
		buffer::str('<option value="1" selected="selected">'.__('yes').'</option><option value="0">'.__('no').'</option>');
	} else {
		buffer::str('<option value="1">'.__('yes').'</option><option value="0" selected="selected">'.__('no').'</option>');
	}
buffer::str('</select></p>');
buffer::str('<p class="field"><label for="width"><strong>'.__('Player size').' :</strong></label><input type="text" size="3" maxlength="3" name="width" value="'.width.'"/> x <input type="text" size="3" maxlength="3" name="height" value="'.height.'"/></p>');
buffer::str('</fieldset>');

// Couleurs
buffer::str('<fieldset style="width: 44.25%; float: left; margin: 0 0 0 2%;">');
buffer::str('<legend>'.__('Display colours').'</legend>');

buffer::str('<p class="field">'.__('Hexadecimal values').', 6 '.__('digits or letters (from 0 to f)').' <strong>'.__('but no').' # '.__('before').'!</strong></p>');
buffer::str('<p class="field"><label for="bgColor"><strong>'.__('Background').' :</strong></label><input type="text" size="6" maxlength="6" name="bgColor" id ="bgColor" value="'.bgColor.'"/></p>');
buffer::str('<p class="field"><label for="bgcolor1"><strong>'.__('First gradient color').' :</strong></label><input type="text" size="6" maxlength="6" name="bgcolor1" id ="bgcolor1" value="'.bgcolor1.'"/></p>');
buffer::str('<p class="field"><label for="bgcolor2"><strong>'.__('Second gradient color').' :</strong></label><input type="text" size="6" maxlength="6" name="bgcolor2" id ="bgcolor2" value="'.bgcolor2.'"/></p>');
buffer::str('<p class="field"><label for="playercolor"><strong>'.__('Player color').' :</strong></label><input type="text" size="6" maxlength="6" name="playercolor" id ="playercolor" value="'.playercolor.'"/></p>');
buffer::str('</fieldset>');
buffer::str('<p class="clear"><input type="submit" name="submit" class="submit" value="'.__('Save').'" /></p>');
buffer::str('<p>' . dcNonce::form() . '</p>');
buffer::str('</form>');
buffer::str('</fieldset>');



//////////////////////////////////////////////////
// Affichage du code pour le player

if (isset($filePath)){
	buffer::str('<fieldset class="clear">');
	buffer::str('<legend>'.__('XHTML Code').'</legend>');
	buffer::str('<p><b>'.__('To insert the player inside your post, you just have copy the code bellow inside it.').'</b></p>');
	
	
	$ext = substr($filePath, -3);
	if ($ext == "mp3"){
		buffer::str('<p>'.dcNeolao::getMp3PlayerCode($playerDirectory,$filePath,autoPlay,bgColor,width,height,displayPodcastLogo,showtime,showstop,showvolume,bgcolor1,bgcolor2,playercolor).'</p>');
	} else if ($ext == "flv"){
		buffer::str('<p>'.dcNeolao::getMoviePlayerCode($playerDirectory,$filePath,autoPlay,bgColor,width,height,displayPodcastLogo,showtime,showstop,showvolume,bgcolor1,bgcolor2,playercolor).'</p>');	
	}
	
	buffer::str('</fieldset>');
}

?>
